<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>Configuration.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">protean-tests</a> &gt; <a href="index.source.html" class="el_package">io.gitlab.littlesaints.protean.configuration</a> &gt; <span class="el_source">Configuration.java</span></div><h1>Configuration.java</h1><pre class="source lang-java linenums">/*
 *                     protean-core
 *              Copyright (C) 2018 Varun Anand
 *
 * This file is part of protean-core.
 *
 * protean-core is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 *
 * protean-core is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see &lt;http://www.gnu.org/licenses/&gt;.
 */

package io.gitlab.littlesaints.protean.configuration;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.dataformat.yaml.YAMLFactory;
import com.littlesaints.protean.functions.streams.Try;
import io.gitlab.littlesaints.protean.Context;
import io.gitlab.littlesaints.protean.context.ContextBuilder;
import io.gitlab.littlesaints.protean.resources.Registrar;
import io.gitlab.littlesaints.protean.resources.ResourceLocator;
import lombok.Getter;
import lombok.Setter;
import lombok.extern.log4j.Log4j2;

import java.io.FileReader;
import java.util.Arrays;
import java.util.Map;
import java.util.Optional;
import java.util.ServiceLoader;
import java.util.concurrent.ConcurrentHashMap;
import java.util.function.Consumer;

/**
 * This represents the configuration for all configured {@link Context}s.
 * &lt;p&gt;
 * Use the methods newInstance prefix 'load', to create an instance from any supported format. This instance can be used to look up a configured {@link Context} using {@link #getContext(String)}.
 *
 * @see Context
 *
 * @author Varun Anand
 * @since 1.0
 */
<span class="fc" id="L52">@Log4j2</span>
<span class="fc" id="L53">public final class Configuration {</span>

    static {
<span class="fc" id="L56">        ServiceLoader.load(Registrar.class).forEach(r -&gt; log.info(&quot;Loading {}&quot;, r));</span>
    }

<span class="fc" id="L59">    public static final ResourceLocator LOCATOR = new ResourceLocator() {</span>

        @Override
        public &lt;T&gt; Optional&lt;T&gt; doLookup(String name) {
<span class="fc" id="L63">            return REGISTRY.stream()</span>
<span class="fc" id="L64">                    .map(l -&gt; l.&lt;T&gt;lookup(name))</span>
<span class="fc" id="L65">                    .filter(Optional::isPresent)</span>
<span class="fc" id="L66">                    .map(Optional::get)</span>
<span class="fc" id="L67">                    .findAny();</span>
        }
    };

<span class="fc" id="L71">	private static final ObjectMapper MAPPER = new ObjectMapper();</span>
<span class="fc" id="L72">	private static final ObjectMapper YAML_MAPPER = new ObjectMapper(new YAMLFactory());</span>

	//TODO: Configuration Registry to auto-load pre-built configurations and workflows. These can then be merged and connected newInstance app specific ones.

<span class="nc" id="L76">	@Getter</span>
<span class="fc" id="L77">	@Setter</span>
	private Map&lt;String, ContextOptions&gt; contexts;

<span class="fc" id="L80">	private final Map&lt;String, ContextOptions&gt; _contextOptions = new ConcurrentHashMap&lt;&gt;();</span>
<span class="fc" id="L81">	private final Map&lt;String, Context&lt;?, ?&gt;&gt; _cachedContexts = new ConcurrentHashMap&lt;&gt;();</span>

    /**
     * Loads the Configuration from json text.
     **/
    public static Configuration loadJsonText(String jsonText) throws Exception {
<span class="nc" id="L87">        final Configuration configuration = MAPPER.readValue(jsonText, Configuration.class);</span>
<span class="nc" id="L88">        configuration._contextOptions.putAll(configuration.contexts);</span>
<span class="nc" id="L89">        return configuration;</span>
    }

    /**
     * Loads the Configuration from json file.
     **/
    public static Configuration loadJsonFile(String fileName) throws Exception {
<span class="nc" id="L96">        final Configuration configuration = MAPPER.readValue(new FileReader(fileName), Configuration.class);</span>
<span class="nc" id="L97">        configuration._contextOptions.putAll(configuration.contexts);</span>
<span class="nc" id="L98">        return configuration;</span>
    }

    /**
     * Loads the Configuration from json file on classpath or further within a jar.
     **/
    public static Configuration loadJsonFileFromClasspath(Class aClass, String fileName) throws Exception {
<span class="pc bpc" id="L105" title="1 of 2 branches missed.">        final Configuration configuration = MAPPER.readValue(aClass.getResourceAsStream(fileName.startsWith(&quot;/&quot;) ? fileName : &quot;/&quot;.concat(fileName)), Configuration.class);</span>
<span class="fc" id="L106">        configuration._contextOptions.putAll(configuration.contexts);</span>
<span class="fc" id="L107">        return configuration;</span>
    }

    /**
     * Loads the Configuration from yaml text.
     **/
    public static Configuration loadYamlText(String jsonText) throws Exception {
<span class="nc" id="L114">        final Configuration configuration = YAML_MAPPER.readValue(jsonText, Configuration.class);</span>
<span class="nc" id="L115">        configuration._contextOptions.putAll(configuration.contexts);</span>
<span class="nc" id="L116">        return configuration;</span>
    }

    /**
     * Loads the Configuration from yaml file.
     **/
    public static Configuration loadYamlFile(String fileName) throws Exception {
<span class="nc" id="L123">        final Configuration configuration = YAML_MAPPER.readValue(new FileReader(fileName), Configuration.class);</span>
<span class="nc" id="L124">        configuration._contextOptions.putAll(configuration.contexts);</span>
<span class="nc" id="L125">        return configuration;</span>
    }

    /**
     * Loads the Configuration from yaml file on classpath or further within a jar.
     **/
    public static Configuration loadYamlFileFromClasspath(Class aClass, String fileName) throws Exception {
<span class="pc bpc" id="L132" title="1 of 2 branches missed.">        final Configuration configuration = YAML_MAPPER.readValue(aClass.getResourceAsStream(fileName.startsWith(&quot;/&quot;) ? fileName : &quot;/&quot;.concat(fileName)), Configuration.class);</span>
<span class="fc" id="L133">        configuration._contextOptions.putAll(configuration.contexts);</span>
<span class="fc" id="L134">        return configuration;</span>
    }

	public Configuration merge(Configuration configurations) {
<span class="nc" id="L138">        _contextOptions.putAll(configurations._contextOptions);</span>
<span class="nc" id="L139">		_cachedContexts.putAll(configurations._cachedContexts);</span>
<span class="nc" id="L140">		return this;</span>
	}

	public static Configuration merge(Configuration... configurations) {
<span class="nc" id="L144">		final Configuration configuration = new Configuration();</span>
<span class="nc" id="L145">		Arrays.stream(configurations).forEach(configuration::merge);</span>
<span class="nc" id="L146">		return configuration;</span>
	}

<span class="fc" id="L149">    private final Try&lt;String, Optional&lt;ContextOptions&gt;&gt; contextOptionsLookup =</span>
<span class="fc" id="L150">            Try.&lt;String, ContextOptions&gt;evaluate(ctx -&gt; MAPPER.readValue(MAPPER.writeValueAsString(_contextOptions.get(ctx)), ContextOptions.class))</span>
<span class="fc" id="L151">                    .wrapWithOptional();</span>

    public Optional&lt;ContextOptions&gt; getContextOptions(String name) {
        //TODO: toString ContextOptions
<span class="fc" id="L155">        return contextOptionsLookup.apply(name);</span>
    }

	/**
	 * Provides a {@link Context} by it's name.
	 *
	 * @param name the context name
	 * @param &lt;P&gt;  The getType of payload dealt newInstance
	 * @param &lt;R&gt; The expected type result
	 * @return the configured context
	 */
	@SuppressWarnings(&quot;unchecked&quot;)
	public &lt;P, R&gt; Optional&lt;Context&lt;P, R&gt;&gt; getContext(String name) {
<span class="pc bpc" id="L168" title="1 of 2 branches missed.">		if (!_contextOptions.containsKey(name)) {</span>
<span class="nc" id="L169">			return Optional.empty();</span>
		}
<span class="pc bpc" id="L171" title="1 of 2 branches missed.">		if (!_cachedContexts.containsKey(name)) {</span>
<span class="nc" id="L172">            _cachedContexts.putIfAbsent(name,</span>
<span class="nc" id="L173">                    ContextBuilder.newInstance(name, this).get());</span>
		}
<span class="fc" id="L175">		return Optional.ofNullable((Context&lt;P, R&gt;) _cachedContexts.get(name));</span>
	}

    @SuppressWarnings(&quot;unchecked&quot;)
	public &lt;P, R&gt; Optional&lt;Context&lt;P, R&gt;&gt; updateContext(String name, ContextOptions options) {
		//TODO: toString ContextOptions
<span class="fc" id="L181">        _contextOptions.put(name, options);</span>
<span class="fc" id="L182">        _cachedContexts.put(name,</span>
<span class="fc" id="L183">                ContextBuilder.newInstance(name, this).get());</span>
<span class="fc" id="L184">        return Optional.of((Context&lt;P, R&gt;) _cachedContexts.get(name));</span>
	}

    public &lt;P, R&gt; Optional&lt;Context&lt;P, R&gt;&gt; updateContext(String name, Consumer&lt;ContextOptions&gt; decorator) {
<span class="nc" id="L188">        final Optional&lt;ContextOptions&gt; contextOptions = getContextOptions(name);</span>
<span class="nc bnc" id="L189" title="All 2 branches missed.">        if (contextOptions.isPresent()) {</span>
<span class="nc" id="L190">            decorator.accept(contextOptions.get());</span>
<span class="nc" id="L191">            return updateContext(name, contextOptions.get());</span>
        }
<span class="nc" id="L193">        return Optional.empty();</span>
    }

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.4.201905082037</span></div></body></html>